/*
 Uccelerate - 0.1.9
*/

var app = angular.module("Uccelerate", ["checklist-model", "ngSanitize"]);

app.controller("master", function ($scope, $http, $timeout) {
  
  $scope.AngularLoaded = true;

  $scope.setCurrency = function(currency){
      $scope.PickedCurrency = currency;
      Helpers.setCookie("currency", currency, 100);
      
      $timeout(function(){
        location.reload(true);
      }, 200);
      
  };

  $scope.getCart = function () {
    $http.post("/Umbraco/Api/Basket/Get", {Culture: $scope.Culture}).then(function (response) {
      $scope.basket = response.data.Basket;
    });
  };

  $scope.addToCart = function (sku, variantsku) {
    $http.post("/Umbraco/Api/Basket/Add", { Sku: sku, VariantSku: variantsku, Quantity: 1 }).then(function (data) {
      $scope.getCart();
    });
  };

  $scope.removeLineItem = function (id) {
    $http.post("/Umbraco/Api/Basket/Update", { NewQuantity: 0, OrderLineId: id }).then(function (data) {
      $scope.getCart();
    });
  };

  $scope.updateLineItem = function (id, amount) {
    $http.post("/Umbraco/Api/Basket/Update", { NewQuantity: amount, OrderLineId: id }).then(function (data) {
      $scope.getCart();
    });
  };
    
  $timeout(function(){
      $scope.getCart();
  },200);
  

  $scope.searchQuery = "";

  $scope.$watch('searchQuery', function () {

    if ($scope.searchQuery.length > 0) {
      $http.post("/Umbraco/Api/Search/Products", { Keyword: $scope.searchQuery, CurrentPage: 0, Amount: 6 }).then(function (response) {
        $scope.searchResult = response.data.Products;

      });
    }
  });

});

app.controller("productCategory", function ($scope, $http, $timeout) {

  $scope.ClearFilter = function () {
    $scope.FilterCount = 0;
    $scope.filter = {
    };
    Helpers.scrollTo("store-container");
  };

  /*Filter and sort*/
  $scope.filter = {
  };

  $scope.FilterCount = 0;
  $scope.SortSelect = "2";
  $scope.CurrentPage = 0;
  $scope.InitiatedPagination = false;
  $scope.FilteredProducts = [];
  $scope.ShowLoader = true;
  $scope.AllLoaded = false;

  $scope.changeFilter = function () {
    $scope.FilterCount = 0;
    $scope.ShowLoader = true;

    for (var prop in $scope.filter) {
      $scope.FilterCount += $scope.filter[prop].length;
    }

    $scope.CurrentPage = 0;
    Helpers.scrollTo("store-container");
    
    $http.post("/Umbraco/Api/Products/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.TotalResult = response.data.TotalResults;
      $scope.InitiatedPagination = true;
      $scope.ShowLoader = false;

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;
      else
        $scope.AllLoaded = false;

        
      
    });
  };

  $scope.loadProducts = function () {
    $http.post("/Umbraco/Api/Products/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.ShowLoader = false;

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;

    });
  };

  $scope.changeSort = function () {
    $scope.ShowLoader = true;
    $scope.CurrentPage = 0;
    $http.post("/Umbraco/Api/Products/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.ShowLoader = false;

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;
      else
        $scope.AllLoaded = false;

    });
  };

  $scope.loadMoreProducts = function () {
    $scope.ShowLoader = true;
    $scope.CurrentPage = $scope.CurrentPage + 1;

    $http.post("/Umbraco/Api/Products/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.ShowLoader = false;
      $scope.FilteredProducts = $scope.FilteredProducts.concat(response.data.Products);

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;
    });

  }
});

app.controller("product", function ($scope, $http, $sce, $timeout) {
  $scope.Review = {};
  $scope.ShowMessage = false;
  $scope.SubmitReview = function () {

    $http.post("/Umbraco/Api/ProductReview/Add", { Title: $scope.Review.Title, Comments: $scope.Review.Comments, Name: $scope.Review.Name, Email: $scope.Review.Email, Rating: $scope.Review.Rating, Sku: $scope.Review.Sku }).then(function (response) {
      $scope.ShowMessage = true;
    });
  }
});


app.controller("checkout", function ($scope, $http, $sce, $timeout) {

  function getCheckoutMarkup() {
   
    if ($scope.CheckoutForm.paymentSelectionLabel.toLowerCase() == "klarna") {
      $http.post("/Umbraco/Api/Checkout/GetKlarnaMarkup", { CountryId: parseInt($scope.CheckoutForm.CountryId) }).then(function (response) {

        $scope.checkoutMarkup = $sce.trustAsHtml("");

        if ($scope.int == 0) {
          $scope.int = 1;
          $scope.checkoutMarkup = $sce.trustAsHtml(response.data.Markup);
        } else {
          //didnt update correctly without this
          $timeout(function () {
            $scope.checkoutMarkup = $sce.trustAsHtml(response.data.Markup);
          }, 200);
        }

      });
    }
  }

  $scope.getCart = function () {
    $http.post("/Umbraco/Api/Basket/Get", { Culture: $scope.Culture }).then(function (response) {
      $scope.basket = response.data.Basket;
    });
  };

  $scope.addToCart = function (sku, variantsku) {
    $http.post("/Umbraco/Api/Basket/Add", { Sku: sku, VariantSku: variantsku, Quantity: 1 }).then(function (data) {
      $scope.getCart();
    });
  };

  $scope.removeLineItem = function (id) {
    $http.post("/Umbraco/Api/Basket/Update", { NewQuantity: 0, OrderLineId: id }).then(function (data) {
      $scope.getCart();
    });
  };

  $scope.updateLineItem = function (id, amount) {
    $http.post("/Umbraco/Api/Basket/Update", { NewQuantity: amount, OrderLineId: id }).then(function (data) {
      $scope.getCart();
    });
  };

  $timeout(function(){
      $scope.getCart();
  },200);
  
  $scope.CheckoutLoading = true;
  $scope.CheckoutForm = {};
  $scope.CheckoutForm.CountryId = "";
  $scope.CheckoutForm.paymentSelectionLabel = "";

  $scope.getShippingAndPaymentMethods = function (UpdatePayment, UpdateShipping) {

    if (typeof $scope.CheckoutForm.CountryId != "undefined"){
    
      $http.post("/Umbraco/Api/Checkout/GetShippingAndPaymentMethods", { CountryId: parseInt($scope.CheckoutForm.CountryId), Culture: $scope.Culture }).then(function (response) {

            if (UpdateShipping) {
              $scope.shippingMethods = response.data.ShippingMethods;
              $scope.CheckoutForm.shippingSelection = String($scope.shippingMethods[0].Id);
            }        
            
            $scope.paymentMethods = response.data.PaymentMethods;
    
            if(UpdatePayment){
              $scope.CheckoutForm.paymentSelection = String($scope.paymentMethods[0].Id);
              $scope.CheckoutForm.paymentSelectionLabel = String($scope.paymentMethods[0].Name);
            }         
            
            getCheckoutMarkup();
            
            $scope.CheckoutLoading = false;
    
        });
    }
  };

  $timeout(function(){
      $scope.getShippingAndPaymentMethods(true, true);
  },200);
  

  function updateCheckout(UpdatePayment, updateShipping) {


    $http.post("/Umbraco/Api/Checkout/SetPaymentAndShipping", { ShipmentId: parseInt($scope.CheckoutForm.shippingSelection), PaymentId: parseInt($scope.CheckoutForm.paymentSelection), CountryId: parseInt($scope.CheckoutForm.CountryId) }).then(function (response) {
      $scope.getCart();
      $scope.discounts = response.data.Discounts;
      
      $scope.getShippingAndPaymentMethods(UpdatePayment, updateShipping);
     
      
    });
  }

  $scope.$watch('CheckoutForm.shippingSelection', function () {
      
    if (typeof $scope.CheckoutForm.paymentSelection != "undefined" && typeof $scope.CheckoutForm.shippingSelection != "undefined" && typeof $scope.CheckoutForm.CountryId != "undefined") {
      
      updateCheckout(true, false);

    }
  });

  
  $scope.SetPaymentMethod = function (method) {
      
      $scope.CheckoutForm.paymentSelection = method.Id;
      $scope.CheckoutForm.paymentSelectionLabel = method.Name;
      
    if (typeof $scope.CheckoutForm.paymentSelection != "undefined" && typeof $scope.CheckoutForm.shippingSelection != "undefined" && typeof $scope.CheckoutForm.CountryId != "undefined") {
      updateCheckout(false, false);    
      
    }
  };

  $scope.$watch('CheckoutForm.ShippingCountryId', function () {

    if (typeof $scope.CheckoutForm.paymentSelection != "undefined" && typeof $scope.CheckoutForm.shippingSelection != "undefined" && typeof $scope.CheckoutForm.ShippingCountryId != "undefined") {
      
      if(!$scope.CheckoutForm.OtherShippingAddress){
          $scope.CheckoutForm.CountryId = $scope.CheckoutForm.ShippingCountryId;
      }
      
      updateCheckout(true, true);

    }
  });


  $scope.setVoucher = function () {
    $http.post("/Umbraco/Api/Voucher/Set", { VoucherCode: $scope.VoucherCodeInput }).then(function (response) {
      $scope.getCart();
      updateCheckout(false, false);
    });
  };

  $scope.placeOrder = function () {
    $http.post("/Umbraco/Api/Order/Submit", $scope.CheckoutForm).then(function (response) {
      window.location.href = window.location.href+"?payment=1"
    });
  }

});

app.controller("search", function ($scope, $http) {
    
  $scope.SearchLoading = false;
  $scope.ClearFilter = function () {
    $scope.FilterCount = 0;
    $scope.filter = {
    };
  }


  /*Filter and sort*/
  $scope.filter = {
  };

  $scope.FilterCount = 0;
  $scope.SortSelect = "2";
  $scope.CurrentPage = 0;
  $scope.InitiatedPagination = false;
  $scope.FilteredProducts = [];
  $scope.ShowLoader = true;
  $scope.AllLoaded = false;


  $scope.postSearch = function () {
    $scope.SearchLoading = true;
    $http.post("/Umbraco/Api/search/Products", { Keyword: $scope.mainSearch, Start: 0, Amount: 0 }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.totalResult = response.data.TotalResult;
      $scope.wordSearched = $scope.mainSearch;
      $scope.SearchLoading = false;

      $scope.currentPage = 1;
      $scope.pages = [];
      if ($scope.totalResult > 0) {
        var pageAmount = 10;
        var pagesAmount = Math.ceil($scope.totalResult / pageAmount, 1);

        for (var i = 0; i < pagesAmount; i++) {
          $scope.pages.push({ PageName: (i + 1) });
        }
      }
    });
  };

  $scope.setPage = function (page) {
    var pageAmount = 10;
    var start = (page - 1) * pageAmount;

    $http.post("/Umbraco/Api/search/Products", { Keyword: $scope.mainSearch, Start: 0, Amount: 0 }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.totalResult = response.data.TotalResult;
      $scope.wordSearched = $scope.mainSearch;
    });
  }


  $scope.postSearch();


});