/*======================================
  #Set browser class
======================================*/
navigator.browserSpecs = (function(){
    var ua= navigator.userAgent, tem,
    M= ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    if(/trident/i.test(M[1])){
        tem=  /\brv[ :]+(\d+)/g.exec(ua) || [];
        return {name:'IE',version:(tem[1] || '')};
    }
    if(M[1]=== 'Chrome'){
        tem= ua.match(/\b(OPR|Edge)\/(\d+)/);
        if(tem!= null) return {name:tem[1].replace('OPR', 'Opera'),version:tem[2]};
    }
    M= M[2]? [M[1], M[2]]: [navigator.appName, navigator.appVersion, '-?'];
    if((tem= ua.match(/version\/(\d+)/i))!= null) M.splice(1, 1, tem[1]);
    return {name:M[0],version:M[1]};
})();

$(function(){
  var OSName="os";
  if (navigator.appVersion.indexOf("Win")!=-1) OSName="windows";
  else if (navigator.appVersion.indexOf("Mac")!=-1) OSName="macos";
  else if (navigator.appVersion.indexOf("X11")!=-1) OSName="unix";
  else if (navigator.appVersion.indexOf("Linux")!=-1) OSName="linux";
  $("body").addClass(OSName);

  if((navigator.userAgent.indexOf("Opera") || navigator.userAgent.indexOf('OPR')) != -1 ) { $('body').addClass('browser-opera'); }
  else if(navigator.userAgent.indexOf("Chrome") != -1 ) { $('body').addClass('browser-chrome'); }
  else if(navigator.userAgent.indexOf("Safari") != -1) { $('body').addClass('browser-safari'); }
  else if(navigator.userAgent.indexOf("Firefox") != -1 ) { $('body').addClass('browser-firefox'); }
  else if((navigator.userAgent.indexOf("MSIE") != -1 ) || (!!document.documentMode == true )){ $('body').addClass('browser-explorer'); }
  else if(navigator.userAgent.indexOf("Edge") != -1 ) { $('body').addClass('browser-edge'); }
  if(navigator.browserSpecs.version){ $('body').addClass('browser-version-'+navigator.browserSpecs.version); }

  var el = document.createElement('div');
  el.setAttribute('ongesturestart', 'return;');
  if(typeof el.ongesturestart == "function"){ $("body").addClass("touch"); }
  else { $("body").addClass("no-touch"); }
});

/*======================================
  #Set .scroll class on scroll
======================================*/
$(function(){
  var body          = $("body"),
    scrollVal       = 1;
    currentScroll   = 0;

  if($(window).scrollTop() > scrollVal){body.addClass("scroll");}

  $(window).on("scroll", function(){
    currentScroll = $(this).scrollTop();
    if(currentScroll > scrollVal){body.addClass("scroll");}
    else{body.removeClass("scroll");}
  });
});

/*======================================
  #Toggle mobile nav
======================================*/
$(function(){
  $(document).on("click", ".toggle-mobile-nav", function(e){
    e.preventDefault();
    $("body").toggleClass("mobile-nav-visible");
  });

  //Toggle mobile second level nav
  $(document).on("click", ".main-nav ul li a .expand", function(e){
    e.preventDefault();
    $(this).toggleClass("open").closest("li").children("ul").slideToggle(200);
  });
});

/*======================================
  #Adjust navigation offscreen
======================================*/
$(window).on("load", function(){
  var navs = $(".main-nav ul ul");
  var screenWidth = $(window).width();
  navs.each(function(){
    var rightEdge = $(this).width() + $(this).offset().left;
    if(rightEdge > screenWidth){
      $(this).addClass("go-right");
    }
  });
});

/*======================================
  #Navigation touch support
======================================*/
$(document).on("touchstart", ".main-nav ul li a", function(e){
    var navLi = $(this).parent("li");
    var navAllLi = $(".main-nav li");
    var dropExist = navLi.children("ul").length;

    if(!navLi.hasClass("touch-open") && dropExist && !$("body").hasClass("mobile-nav-visible")){
      e.preventDefault();
      var parentLi = navLi.closest(".touch-open");
      navAllLi.not(parentLi).removeClass("touch-open");
      navLi.addClass("touch-open");
    }
    else if(dropExist){
      navAllLi.removeClass("touch-open");
    }
});

/*======================================
  #Scroll to top
======================================*/
$(function(){
  $(document).on("click", ".to-top", function(e){
    e.preventDefault();
    $("html, body").animate({scrollTop: 0}, 500);
  });
});

/*======================================
  #Lazyload images
======================================*/
$(function() {
  $(".lazy").lazyload({
    threshold : 1000
  });
});

/*======================================
  #Responsive video
======================================*/
$(document).ready(function(){
  $("body").fitVids();
});

/*======================================
  #Umbraco forms - Success scroll
======================================*/
$(window).on("load", function(){
  if ($(".umbraco-forms-submitmessage").length){
      var v = ($( ".umbraco-forms-submitmessage").offset().top - 120);
      $("html, body").animate({scrollTop: v}, 500);
  }
});

/*======================================
  #Googlemap
======================================*/
$(function(){
  if ($(".map .map-canvas").length){
    $(".map .map-canvas").each(function(){

      var map = $(this),
          mapCanvas = map[0],
          lat = map.data("lat"),
          long = map.data("long"),
          zoom = map.data("zoom"),
          pin = map.data("pin");

      var mapOptions = {
          center: new google.maps.LatLng(lat, long),
          zoom: zoom,
          scrollwheel: false
      };

      var mapobj = new google.maps.Map(mapCanvas, mapOptions);

      if(pin == "no"){
         var marker = new google.maps.Marker({
          position: new google.maps.LatLng(lat, long),
          map: mapobj
        });
      }
      else{
        var image = {
            url: pin,
            scaledSize: new google.maps.Size(50, 50),
        };

        var marker = new google.maps.Marker({
          position: new google.maps.LatLng(lat, long),
          map: mapobj,
          optimized: false,
          icon: image
        });
      }

    });
  }

});

/*======================================
  #PhotoSwipe gallery
======================================*/
$(function(){
  if ($(".gallery").length){

    $('.gallery').each( function() {
        var $pic     = $(this),
            getItems = function() {
                var items = [];
                $pic.find('a').each(function() {
                    var $href   = $(this).attr('href'),
                        $size   = $(this).data('size').split('x'),
                        $width  = $size[0],
                        $height = $size[1];

                    var item = {
                        src : $href,
                        w   : $width,
                        h   : $height
                    };

                    items.push(item);
                });
                return items;
            };

        var items = getItems();

        var $pswp = $('.pswp')[0];
        $pic.on('click', 'figure', function(event) {
          event.preventDefault();

          var $index = $(this).index();
          var options = {
              index: $index,
              bgOpacity: 0.9,
              showHideOpacity: true,
              shareEl: false,
              getThumbBoundsFn: function($index) {
                var thumbnail = document.querySelectorAll('.gallery-item img')[$index];
                var pageYScroll = window.pageYOffset || document.documentElement.scrollTop;
                var rect = thumbnail.getBoundingClientRect(); 
                return {x:rect.left, y:rect.top + pageYScroll, w:rect.width};
            }
          };

          // Initialize PhotoSwipe
          var lightBox = new PhotoSwipe($pswp, PhotoSwipeUI_Default, items, options);
          lightBox.init();
      });
    });
  }
});

/*======================================
  #Instagram
======================================*/
$(function(){
	if ($("#instafeed").length){
		$("#instafeed").each(function(){
			
			var wrap = $(this),
		        count = wrap.data("count"),  
		        link = wrap.data("link"),
		        icon = wrap.data("icon"),
		        token = wrap.data("token"),
		        user = wrap.data("user"),
		        username = wrap.data("username"),
		        imagewidth = wrap.data("imagewidth"),
		        template = "",
		        linkstart = "",
		        linkend = "",
		        iconlink = "";

		        if(link == "1"){
		        	linkstart = '<a href="{{link}}" class="instagram-image-link" target="_blank">';
		        	linkend = '</a>';
		        }

		        if(icon == "1"){
		        	iconlink = '<a target="_blank" class="instagram-user-link" href="https://www.instagram.com/'+ username +'"><i class="fa fa-instagram"></a></i>';
		        }

		        template = '<div class="col-'+ imagewidth +'"><div class="gallery-item"><figure>'+iconlink+''+linkstart+'<span class="bg" style="display:block;background-size:cover;background-position:center; padding-top: 100%; width: 100%; height: 100% ;background-image: url({{image}});" alt="{{caption}}"></span>'+linkend+'</figure></div></div>';

			// Get images
			var feed = new Instafeed({
		    	userId: user,
		    	accessToken: token,
		        get: 'user',
				limit: count,		
				template: template,
				resolution: 'standard_resolution'
		    });
		    feed.run();
		});
	}	
});

/*======================================
  #Accordion
======================================*/
$(function(){
  $(document).on("click", ".acc-head", function(e){
    e.preventDefault();
    $(this).parent(".acc").toggleClass("open");
    $(this).next(".acc-body").slideToggle(300);
  });
});

/*======================================
  #Share modals
======================================*/
$(function(){
  $(document).on("click", ".share-list a", function(e){
      if($(window).width() > 768){
        e.preventDefault();
        var targetUrl = $(this).attr("href");
        var winWidth = $(this).data("width");
        var winHeight = $(this).data("height");
        PopupCenter(targetUrl,'sharer',winWidth,winHeight);
      }
  });
});

function PopupCenter(url, title, w, h) {
    var dualScreenLeft = window.screenLeft != undefined ? window.screenLeft : screen.left;
    var dualScreenTop = window.screenTop != undefined ? window.screenTop : screen.top;

    var width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
    var height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

    var left = ((width / 2) - (w / 2)) + dualScreenLeft;
    var top = ((height / 2) - (h / 2)) + dualScreenTop;
    var newWindow = window.open(url, title, 'scrollbars=yes, width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);

    if (window.focus) {
        newWindow.focus();
    }
}


/*======================================
  #Contact Form
======================================*/
$(function(){
  $('#contact-form').on('submit', function(e){
    if($("#contact-form")[0].checkValidity()){
      e.preventDefault();

      var $form = $(this);

      $.ajax({
        url: $form.data('posturl'),
        method: "POST",
        data: $form.serialize(),
        success: function(data){
          $form.html('<p class="contourMessageOnSubmit">'+$form.data('thankyoumessage')+'</p>');
        }
      });
    }
  });
  
  $('.newsletter form').on('submit', function(e){
    if($(".newsletter form")[0].checkValidity()){
      e.preventDefault();
      var $form = $(this);
      $.ajax({
        url: $form.attr('action'),
        method: "POST",
        data: $form.serialize(),
        success: function(data){
          $form.replaceWith('<p class="contourMessageOnSubmit">'+$form.data('thankyoumessage')+'</p>');
        }
      });
    }
  });
});


/*======================================
  #Video
======================================*/
$(function(){
  // Toggle video sound
  $(document).on("click", ".video-mute", function(e){
      e.preventDefault();
      $(this).toggleClass("sound-on");
      var video = $(this).prev(".hero-video").children(".hero-video__player");
      video.prop('muted', !video.prop('muted'));
  });
});

/*======================================
  #Minicart
======================================*/
$(function () {
  $(document).on("click touchstart", ".toggle-cart a", function(e){
    e.preventDefault();
    $("body").addClass("mini-cart-visible");     
  });

  $(document).on("click", ".add-to-cart", function(e){
    e.preventDefault();
    $("body").addClass("mini-cart-visible");     
  });

  $(document).on("click touchstart", ".mini-cart-overlay", function () {
    $("body").removeClass("mini-cart-visible");
  });
});

/*======================================
  #Search
======================================*/
$(function () {
    $(document).on("click touchstart", ".toggle-search a, .show-search", function (e) {
        e.preventDefault();
        $("body").addClass("search-visible");
        
        setTimeout(function () {
            $(".search__input").focus();
        }, 600);
    });
  
    $(document).on("click touchstart", ".search-overlay", function(){
        $("body").removeClass("search-visible");      
    });

    $(document).on("input", ".search .search__input", function (e) {
        if ($(this).val() == "") {
          $(".search__prefilled").slideDown(200);
          $(".search__autocomplete").slideUp(200);
        }
        else {
          $(".search__prefilled").slideUp(200);
          $(".search__autocomplete").slideDown(200);
        }
    });

    $(document).on("input", ".search-block .search__input", function (e) {
        $(".search-block__text-bg").text($(this).val());
    });

    $(document).on("click touchstart", ".search__close", function () {
        $("body").removeClass("search-visible");
    });
});

/*======================================
  #Filter
======================================*/
$(function () {
  $(document).on("click touchstart", ".toggle-store-filter", function (e) {
    e.preventDefault();
    $("body").addClass("store-filter-visible");
  });

  $(document).on("click touchstart", ".store-filter-overlay, .hide-filter", function (e) {
      e.preventDefault();
    $("body").removeClass("store-filter-visible");
  });
  
  $(document).on("click ", ".store-filter-section header", function(){
   $(this).parent().toggleClass("store-filter-section--open");
  });
});

/*======================================
  #Grid
======================================*/
$(function () {
  $(document).on("mouseenter", ".product", function () {
    var extra = $(this).find(".extra");

    if (extra.length && !extra.hasClass("loaded")) {
      var imageUrl = extra.data("image");
      extra.css('background-image', 'url(' + imageUrl + ')').addClass("loaded");
    }

  });
});

/*======================================
  #Tabs
======================================*/
$(function(){
    $(document).on("click", ".tabs-nav a:not(.active)", function(e){
        e.preventDefault();

        $(this).closest("ul").find("a").removeClass("active");
        $(this).addClass("active");
        var target = $(this).attr("href");

        $(this).closest(".tabs-nav").next(".tabs-container").find(".tab--active").slideUp(300).removeClass("tab--active");
        $(target).slideDown(300);

        setTimeout(function(){
            $(target).addClass("tab--active");
        },300);

    });
});

/*======================================
  #PhotoSwipe gallery
======================================*/
$(function(){
  if ($(".product-post__media").length){

    $('.product-post__media').each( function() {
        var $pic     = $(this),
            getItems = function() {
                var items = [];
                $pic.find('a.product-post__toggle-gallery').each(function() {
                    var $href   = $(this).attr('href'),
                        $size   = $(this).data('size').split('x'),
                        $width  = $size[0],
                        $height = $size[1];
     
                    var item = {
                        src : $href,
                        w   : $width,
                        h   : $height
                    }
     
                    items.push(item);
                });
                return items;
            }
     
        var items = getItems();

        var $pswp = $('.pswp')[0];
        $pic.on('click', '.product-post__toggle-gallery', function(event) {
          event.preventDefault();
           
          var $index = $(this).parent("figure").parent().index();
          var options = {
              index: $index,
              bgOpacity: 0.9,
              showHideOpacity: true,
              shareEl: false,
              getThumbBoundsFn: function($index) {
                var thumbnail = document.querySelectorAll('.pw-thumb')[$index];
                var pageYScroll = window.pageYOffset || document.documentElement.scrollTop; 
                var rect = thumbnail.getBoundingClientRect(); 
                return {x:rect.left, y:rect.top + pageYScroll, w:rect.width};
            }
          }
           
          // Initialize PhotoSwipe
          var lightBox = new PhotoSwipe($pswp, PhotoSwipeUI_Default, items, options);
          lightBox.init();
      });

    });

  }

});

/*======================================
  #Review
======================================*/
$(function () {
  $(document).on("click", ".rating-input.rating--set span", function (e) {

    $(this).siblings().removeClass("selected");
    $(this).addClass("selected").nextAll().addClass("selected");

    var rating = $(this).data("val");

    $("#input-rating").val(rating);

    if (!$(".review-form__body").is(":visible")) {
      $(".review-form__body").slideDown(300);
    }

  });
  
  //Add some random colors to review avatars
  if ($(".review").length){
        var avatarColors = ["#E6567A", "#BADA55", "#1DABB8", "#FCB941", "#8870FF", "#B0DACC", "#F5CD79", "#F8A5C2", "#485460", "#05C46B", "#F53B57", "#34E7E4", "#00B894", "#636E72"];
    
        $(".review__avatar").each(function(){
          var random = Math.floor(Math.random() * avatarColors.length);
          $(this).css("background-color", avatarColors[random]);
        });
    };
});


/*======================================
  #Checkout
======================================*/
$(function () {
    // Radio box toggle
    $(document).on("change", ".radio-box input", function(){
        $(this).closest(".radio-box-wrap").children(".radio-box.selected").removeClass("selected");
        $(this).closest(".radio-box").addClass("selected");
    });

    // Toggle Voucher form
    $(document).on("click", ".voucher-code > a", function(e){
       $(".co-voucher-code").slideToggle(200);
    });

    // Payment tabs
    $(document).on("click", "ul.payment-options li:not(.selected) a", function(e){
        e.preventDefault();
        var target = $(this).attr("href");
        $("ul.payment-options li").removeClass("selected");
        $(this).parent("li").addClass("selected");

        $(".payment-content").hide();
        $(target).show();
    });

    // Toggle alt delivery info
    $(document).on("change", "#toggle-alt-delivery", function(){
        if($(this).is(":checked")){
          $(".alt-delivery").slideDown(200);
        }
        else{
          $(".alt-delivery").slideUp(200);
        }
    });
});

/*======================================
  #Page loaded
======================================*/
$(window).on("load", function(){
  $("body").addClass("page-loaded").removeClass("page-loading");
});
